#include <ctype.h>
#include <string.h>
#include <stdlib.h>

#include "pw.h"

/* Return 0 if incorrect PNR */
int
pnr_checkpnr (char *persnr)
{
    int i;
    int slutvaerde;
    int a,b, control;
    
    if ((strlen(persnr) != 10))
	return 0;
    control = 10*(persnr[2] - '0') + (persnr[3] - '0');
    if (!(control <= 12))
	return 0;
    control = 10*(persnr[4] - '0') + (persnr[5] - '0');
    if (!(control <= 31))
	return 0;
    
    for(i = 1; i < 9; i++){
	if (!isdigit (persnr[i])){
	    if (i == 6){
		if (!isalpha(persnr[6])){
		    return 0;
		}
	    }
	    else
		return 0;
	}
    }
    if (isalpha (persnr[6]))
	return 1;
    a = 0;
    for(i=1; i<=7; i+=2)
    {
	a = a + (persnr[i] - '0');
    }

    b = 0;
    for(i = 0; i <= 8; i += 2)
    {
	b += (2 * (persnr[i] - '0')) / 10;
	b += (2 * (persnr[i] - '0')) % 10;  
    }  
    if((a + b + (persnr[9] - '0')) % 10 == 0)
	return 1;
    return 0;
}

